Description

You can add the "Files" column to the issues list. In the column, names of the attached files are shown and each filename is linked to

the preview page of the file.

I think the UI can be improved to place a download icon beside the filename, like attachments on issue pages or wiki pages.

Currently, you need to click twice to download the file (1. click the filename on the issues list, 2. click the download link on the

preview page). If the column has download buttons, you can reduce an extra one click.

Before:

 

After:

 

Associated revisions

Revision 19500 - 2020-02-06 15:24 - Go MAEDA

Add download buttons in Files columns of the issues list (#32240).

Patch by Yuichi HARADA.

History

#1 - 2019-10-11 07:33 - Anonymous

+1 ofc ;-)
#2 - 2019-10-11 21:56 - Mischa The Evil

Go MAEDA wrote:

[...] Currently, you need to click twice to download the file [...]

 I am not able to test this currently, but what about right-click -> save as? Doesn't that work in any way?

#3 - 2019-10-12 02:08 - Go MAEDA

Mischa The Evil wrote:

I am not able to test this currently, but what about right-click -> save as? Doesn't that work in any way?

 Unfortunately, it does not work. It saves the HTML content of the preview page (AttachmentsController#show).

#4 - 2019-11-07 06:07 - Yuichi HARADA

- File 32240_add_download_button.patch added

Go MAEDA wrote:

If the column has download buttons, you can reduce an extra one click.

 Added download buttons to "Files" column. I attached a patch.

#5 - 2019-11-07 21:53 - Marius BĂLTEANU

In my opinion, there are too many icons in the listing which make the "Files" column more obvious than the other columns (my first reaction is look on

that column). If we really want to have the download links available in the listing, what about of showing the icon only on hover?

#6 - 2019-11-08 02:01 - Yuichi HARADA

- File 32240_add_download_button_v2.patch added

Marius BALTEANU wrote:

In my opinion, there are too many icons in the listing which make the "Files" column more obvious than the other columns (my first reaction is

look on that column). If we really want to have the download links available in the listing, what about of showing the icon only on hover?

 Thank you for your feedback. Fixed to show the download icon only when hovering.

#7 - 2019-11-09 07:55 - Go MAEDA

- Target version set to Candidate for next major release

#8 - 2020-01-30 02:53 - Go MAEDA

- Target version changed from Candidate for next major release to 4.2.0

LGTM. Setting the target version to 4.2.0.

#9 - 2020-02-04 07:30 - Go MAEDA

The patch breaks a test.

F

Failure:

AttachmentFieldFormatTest#test_create_with_attachment [/Users/maeda/redmines/trunk/test/integration/lib/redmin

e/field_format/attachment_format_test.rb:85]:

Expected: 1

  Actual: 2

bin/rails test test/integration/lib/redmine/field_format/attachment_format_test.rb:54

#10 - 2020-02-05 02:57 - Yuichi HARADA

- File 32240_add_download_button_v3.patch added
Go MAEDA wrote:

The patch breaks a test.

[...]

 Sorry, I fixed the test as follows.

diff --git a/test/integration/lib/redmine/field_format/attachment_format_test.rb b/test/integration/lib/redmin

e/field_format/attachment_format_test.rb

index 61f439894..ccb33a9b6 100644

--- a/test/integration/lib/redmine/field_format/attachment_format_test.rb

+++ b/test/integration/lib/redmine/field_format/attachment_format_test.rb

@@ -81,7 +81,7 @@ class AttachmentFieldFormatTest < Redmine::IntegrationTest

     assert_response :success

     # link to the attachment

-    link = css_select(".cf_#{@field.id} .value a")

+    link = css_select(".cf_#{@field.id} .value a:not(.icon-download)")

     assert_equal 1, link.size

     assert_equal "testfile.txt", link.text

#11 - 2020-02-05 07:48 - Go MAEDA

- File 32240_add_download_button_v4.patch added

I have slightly updated the patch as follows:

Fixed a "Layout/ArgumentAlignment" RuboCop warning in app/helpers/application_helper.rb

Changed the CSS to hide the icon from "display: none;" from "visibility: hide;" in order to prevent the table cell width from changing on mouse

hover

#12 - 2020-02-06 15:25 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for your contribution.

Files

before@2x.png 45.4 KB 2019-10-11 Go MAEDA

after@2x.png 50.3 KB 2019-10-11 Go MAEDA
